/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.entity.DataCrkywRmdjDefault;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.mapper.DataCrkywRmdjDefaultMapper;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.param.DataCrkywRmdjDefaultAddParam;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.param.DataCrkywRmdjDefaultEditParam;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.param.DataCrkywRmdjDefaultIdParam;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.param.DataCrkywRmdjDefaultPageParam;
import com.unis.intelligentManagement.modular.dataCrkywRmdjDefault.service.DataCrkywRmdjDefaultService;

import java.util.List;

/**
 * 出入库登记Service接口实现类
 *
 * @author hjc
 * @date  2024/06/07 17:58
 **/
@Service
public class DataCrkywRmdjDefaultServiceImpl extends ServiceImpl<DataCrkywRmdjDefaultMapper, DataCrkywRmdjDefault> implements DataCrkywRmdjDefaultService {

    @Override
    public Page<DataCrkywRmdjDefault> page(DataCrkywRmdjDefaultPageParam dataCrkywRmdjDefaultPageParam) {
        QueryWrapper<DataCrkywRmdjDefault> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(dataCrkywRmdjDefaultPageParam.getSortField(), dataCrkywRmdjDefaultPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(dataCrkywRmdjDefaultPageParam.getSortOrder());
            queryWrapper.orderBy(true, dataCrkywRmdjDefaultPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(dataCrkywRmdjDefaultPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByDesc(DataCrkywRmdjDefault::getBuilddate);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(DataCrkywRmdjDefaultAddParam dataCrkywRmdjDefaultAddParam) {
        DataCrkywRmdjDefault dataCrkywRmdjDefault = BeanUtil.toBean(dataCrkywRmdjDefaultAddParam, DataCrkywRmdjDefault.class);
        this.save(dataCrkywRmdjDefault);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(DataCrkywRmdjDefaultEditParam dataCrkywRmdjDefaultEditParam) {
        DataCrkywRmdjDefault dataCrkywRmdjDefault = new DataCrkywRmdjDefault();
        BeanUtil.copyProperties(dataCrkywRmdjDefaultEditParam, dataCrkywRmdjDefault);
        this.updateById(dataCrkywRmdjDefault);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<DataCrkywRmdjDefaultIdParam> dataCrkywRmdjDefaultIdParamList) {
        // 执行删除
    }

    @Override
    public DataCrkywRmdjDefault detail(DataCrkywRmdjDefaultIdParam dataCrkywRmdjDefaultIdParam) {
        return this.queryEntity(dataCrkywRmdjDefaultIdParam.getId());
    }

    @Override
    public DataCrkywRmdjDefault queryEntity(String id) {
        DataCrkywRmdjDefault dataCrkywRmdjDefault = this.getById(id);
        if(ObjectUtil.isEmpty(dataCrkywRmdjDefault)) {
            throw new CommonException("出入库登记不存在，id值为：{}", id);
        }
        return dataCrkywRmdjDefault;
    }
}
